diff --git a/tools/update-packaging/make_incremental_updates.py b/tools/update-packaging/make_incremental_updates.py
index dc7b3a01ea..07cfe5bcb6 100755
--- a/tools/update-packaging/make_incremental_updates.py
+++ b/tools/update-packaging/make_incremental_updates.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os
 import shutil
 import hashlib
@@ -46,11 +47,11 @@ class PatchInfo:
         if m:
             # Directory immediately following extensions is used for the test
             testdir = m.group(1)
-            print '     add-if "'+testdir+'" "'+filename+'"'
+            print('     add-if "'+testdir+'" "'+filename+'"')
             self.manifestv2.append('add-if "'+testdir+'" "'+filename+'"')
             self.manifestv3.append('add-if "'+testdir+'" "'+filename+'"')
         else:
-            print '        add "'+filename+'"'
+            print('        add "'+filename+'"')
             self.manifestv2.append('add "'+filename+'"')
             self.manifestv3.append('add "'+filename+'"')
 
@@ -59,7 +60,7 @@ class PatchInfo:
             This was ported from mozilla/tools/update-packaging/common.sh's
             make_add_if_not_instruction.
         """
-        print ' add-if-not "'+filename+'" "'+filename+'"'
+        print(' add-if-not "'+filename+'" "'+filename+'"')
         self.manifestv3.append('add-if-not "'+filename+'" "'+filename+'"')
 
     def append_patch_instruction(self, filename, patchname):
@@ -76,11 +77,11 @@ class PatchInfo:
         m = re.match("((?:|.*/)distribution/extensions/.*)/", filename)
         if m:
             testdir = m.group(1)
-            print '   patch-if "'+testdir+'" "'+patchname+'" "'+filename+'"'
+            print('   patch-if "'+testdir+'" "'+patchname+'" "'+filename+'"')
             self.manifestv2.append('patch-if "'+testdir+'" "'+patchname+'" "'+filename+'"')
             self.manifestv3.append('patch-if "'+testdir+'" "'+patchname+'" "'+filename+'"')
         else:
-            print '      patch "'+patchname+'" "'+filename+'"'
+            print('      patch "'+patchname+'" "'+filename+'"')
             self.manifestv2.append('patch "'+patchname+'" "'+filename+'"')
             self.manifestv3.append('patch "'+patchname+'" "'+filename+'"')
 
@@ -90,16 +91,16 @@ class PatchInfo:
             mozilla/tools/update-packaging/common.sh/make_remove_instruction
         """
         if filename.endswith("/"):
-            print '      rmdir "'+filename+'"'
+            print('      rmdir "'+filename+'"')
             self.manifestv2.append('rmdir "'+filename+'"')
             self.manifestv3.append('rmdir "'+filename+'"')
         elif filename.endswith("/*"):
             filename = filename[:-1]
-            print '    rmrfdir "'+filename+'"'
+            print('    rmrfdir "'+filename+'"')
             self.manifestv2.append('rmrfdir "'+filename+'"')
             self.manifestv3.append('rmrfdir "'+filename+'"')
         else:
-            print '     remove "'+filename+'"'
+            print('     remove "'+filename+'"')
             self.manifestv2.append('remove "'+filename+'"')
             self.manifestv3.append('remove "'+filename+'"')
 
@@ -217,7 +218,7 @@ def xzunzip_file(filename):
 def extract_mar(filename, work_dir):
     """ Extracts the marfile intot he work_dir
         assumes work_dir already exists otherwise will throw osError"""
-    print "Extracting "+filename+" to "+work_dir
+    print("Extracting "+filename+" to "+work_dir)
     saved_path = os.getcwd()
     try:
         os.chdir(work_dir)
@@ -229,7 +230,7 @@ def create_partial_patch_for_file(from_marfile_entry, to_marfile_entry, shas, pa
     """ Creates the partial patch file and manifest entry for the pair of files passed in
     """
     if not (from_marfile_entry.sha(),to_marfile_entry.sha()) in shas:
-        print 'diffing "'+from_marfile_entry.name+'\"'
+        print('diffing "'+from_marfile_entry.name+'\"')
         #bunzip to/from
         bunzip_file(from_marfile_entry.abs_path)
         bunzip_file(to_marfile_entry.abs_path)
@@ -343,7 +344,7 @@ def create_partial_patch(from_dir_path, to_dir_path, patch_filename, shas, patch
     elif "Contents\Resources\precomplete" in to_file_set:
         forced_list.append("Contents\Resources\precomplete")
     else:
-        raise Exception, "missing precomplete file in: "+to_dir_path
+        raise Exception("missing precomplete file in: "+to_dir_path)
 
     if "removed-files" in to_file_set:
         forced_list.append("removed-files")
@@ -353,7 +354,7 @@ def create_partial_patch(from_dir_path, to_dir_path, patch_filename, shas, patch
     elif "Contents\Resources\\removed-files" in to_file_set:
         forced_list.append("Contents\Resources\\removed-files")
     else:
-        raise Exception, "missing removed-files file in: "+to_dir_path
+        raise Exception("missing removed-files file in: "+to_dir_path)
 
     if "chrome.manifest" in to_file_set:
         forced_list.append("chrome.manifest")
@@ -363,7 +364,7 @@ def create_partial_patch(from_dir_path, to_dir_path, patch_filename, shas, patch
     elif "Contents\Resources\\chrome.manifest" in to_file_set:
         forced_list.append("Contents\Resources\\chrome.manifest")
     else:
-        raise Exception, "missing chrome.manifest file in: "+to_dir_path
+        raise Exception("missing chrome.manifest file in: "+to_dir_path)
 
     # Files which exist in both sets need to be patched
     patch_filenames = list(from_file_set.intersection(to_file_set))
@@ -375,7 +376,7 @@ def create_partial_patch(from_dir_path, to_dir_path, patch_filename, shas, patch
             # This filename is in the add if not list, explicitly add-if-not
             create_add_if_not_patch_for_file(to_dir_hash[filename], patch_info)
         elif filename in forced_list:
-            print 'Forcing "'+filename+'"'
+            print('Forcing "'+filename+'"')
             # This filename is in the forced list, explicitly add
             create_add_patch_for_file(to_dir_hash[filename], patch_info)
         else:
@@ -422,8 +423,8 @@ def create_partial_patch(from_dir_path, to_dir_path, patch_filename, shas, patch
     return patch_filename
 
 def usage():
-    print "-h for help"
-    print "-f for patchlist_file"
+    print("-h for help")
+    print("-f for patchlist_file")
 
 def get_buildid(work_dir):
     """ extracts buildid from MAR
@@ -432,7 +433,7 @@ def get_buildid(work_dir):
     if not os.path.exists(ini):
         ini = '%s/Contents/Resources/application.ini' % work_dir
         if not os.path.exists(ini):
-            print 'WARNING: application.ini not found, cannot find build ID'
+            print('WARNING: application.ini not found, cannot find build ID')
             return ''
 
     fd, tmppath = tempfile.mkstemp('', 'tmp', os.getcwd())
@@ -460,7 +461,7 @@ def decode_filename(filepath):
         '(?P<product>\w+)(-)(?P<version>\w+\.\w+(\.\w+){0,2})(\.)(?P<locale>.+?)(\.)(?P<platform>.+?)(\.)(?P<type>\w+)(.mar)',
       os.path.basename(filepath))
       return m.groupdict()
-    except Exception, exc:
+    except Exception as exc:
       try:
         m = re.search(
           '(?P<platform>.+?)\/(?P<locale>.+?)\/(?P<product>\w+)-(?P<version>\w+\.\w+)\.(?P<type>\w+).mar',
@@ -477,7 +478,7 @@ def create_partial_patches(patches):
     metadata = []
     try:
         work_dir_root = tempfile.mkdtemp('-fastmode', 'tmp', os.getcwd())
-        print "Building patches using work dir: %s" % (work_dir_root)
+        print("Building patches using work dir: %s" % (work_dir_root))
 
         # Iterate through every patch set in the patch file
         patch_num = 1
@@ -533,7 +534,7 @@ def create_partial_patches(patches):
              'locale':from_decoded['locale'],
              'platform':from_decoded['platform'],
             })
-            print "done with patch %s/%s time (%.2fs/%.2fs/%.2fs) (mar/patch/total)" % (str(patch_num),str(len(patches)),mar_extract_time-startTime,time.time()-mar_extract_time,time.time()-startTime)
+            print("done with patch %s/%s time (%.2fs/%.2fs/%.2fs) (mar/patch/total)" % (str(patch_num),str(len(patches)),mar_extract_time-startTime,time.time()-mar_extract_time,time.time()-startTime))
             patch_num += 1
         return metadata
     finally:
diff --git a/xpcom/idl-parser/xpidl/header.py b/xpcom/idl-parser/xpidl/header.py
index 8e854c4da8..9e5fe08e31 100644
--- a/xpcom/idl-parser/xpidl/header.py
+++ b/xpcom/idl-parser/xpidl/header.py
@@ -10,7 +10,7 @@
 import sys
 import os.path
 import re
-import xpidl
+from . import xpidl
 import itertools
 import glob
 
@@ -410,7 +410,7 @@ def write_interface(iface, fd):
 
     names = uuid_decoder.match(iface.attributes.uuid).groupdict()
     m3str = names['m3'] + names['m4']
-    names['m3joined'] = ", ".join(["0x%s" % m3str[i:i+2] for i in xrange(0, 16, 2)])
+    names['m3joined'] = ", ".join(["0x%s" % m3str[i:i+2] for i in range(0, 16, 2)])
 
     if iface.name[2] == 'I':
         implclass = iface.name[:2] + iface.name[3:]
diff --git a/xpcom/idl-parser/xpidl/runtests.py b/xpcom/idl-parser/xpidl/runtests.py
index 89222d5467..42d596766f 100644
--- a/xpcom/idl-parser/xpidl/runtests.py
+++ b/xpcom/idl-parser/xpidl/runtests.py
@@ -7,8 +7,8 @@
 
 import mozunit
 import unittest
-import xpidl
-import header
+from . import xpidl
+from . import header
 
 
 class TestParser(unittest.TestCase):
diff --git a/xpcom/idl-parser/xpidl/typelib.py b/xpcom/idl-parser/xpidl/typelib.py
index 911e3873da..79d2d30964 100644
--- a/xpcom/idl-parser/xpidl/typelib.py
+++ b/xpcom/idl-parser/xpidl/typelib.py
@@ -7,9 +7,10 @@
 
 """Generate an XPIDL typelib for the IDL files specified on the command line"""
 
+from __future__ import print_function
 import os
 import sys
-import xpidl
+from . import xpidl
 import xpt
 
 # A map of xpidl.py types to xpt.py types
@@ -274,14 +275,14 @@ if __name__ == '__main__':
 
     if options.regen:
         if options.cachedir is None:
-            print >>sys.stderr, "--regen requires --cachedir"
+            print("--regen requires --cachedir", file=sys.stderr)
             sys.exit(1)
 
         p = xpidl.IDLParser(outputdir=options.cachedir, regen=True)
         sys.exit(0)
 
     if options.depfile is not None and options.outfile is None:
-        print >>sys.stderr, "-d requires -o"
+        print("-d requires -o", file=sys.stderr)
         sys.exit(1)
 
     if options.outfile is not None:
@@ -302,6 +303,6 @@ if __name__ == '__main__':
         depfd = open(options.depfile, 'w')
         deps = [dep.replace('\\', '/') for dep in idl.deps]
 
-        print >>depfd, "%s: %s" % (options.outfile, " ".join(deps))
+        print("%s: %s" % (options.outfile, " ".join(deps)), file=depfd)
         for dep in deps:
-            print >>depfd, "%s:" % dep
+            print("%s:" % dep, file=depfd)
diff --git a/xpcom/idl-parser/xpidl/xpidl.py b/xpcom/idl-parser/xpidl/xpidl.py
index 6bb1ad5de5..99e508fbb6 100755
--- a/xpcom/idl-parser/xpidl/xpidl.py
+++ b/xpcom/idl-parser/xpidl/xpidl.py
@@ -7,6 +7,7 @@
 
 """A parser for cross-platform IDL (XPIDL) files."""
 
+from __future__ import print_function
 import sys
 import os.path
 import re
@@ -36,7 +37,7 @@ def attlistToIDL(attlist):
         return ''
 
     attlist = list(attlist)
-    attlist.sort(cmp=lambda a, b: cmp(a[0], b[0]))
+    attlist.sort(key=lambda a: a[0])
 
     return '[%s] ' % ','.join(["%s%s" % (name, value is not None and '(%s)' % value or '')
                               for name, value, aloc in attlist])
@@ -113,7 +114,7 @@ class Builtin(object):
 
     def nativeType(self, calltype, shared=False, const=False):
         if const:
-            print >>sys.stderr, IDLError("[const] doesn't make sense on builtin types.", self.location, warning=True)
+            print(IDLError("[const] doesn't make sense on builtin types.", self.location, warning=True), file=sys.stderr)
             const = 'const '
         elif calltype == 'in' and self.nativename.endswith('*'):
             const = 'const '
@@ -173,7 +174,7 @@ class Location(object):
 
     def pointerline(self):
         def i():
-            for i in xrange(0, self._colno):
+            for i in range(0, self._colno):
                 yield " "
             yield "^"
 
@@ -201,7 +202,7 @@ class NameMap(object):
         return self._d[key]
 
     def __iter__(self):
-        return self._d.itervalues()
+        return iter(self._d.values())
 
     def __contains__(self, key):
         return key in builtinMap or key in self._d
@@ -374,10 +375,10 @@ class Forward(object):
         # Hack alert: if an identifier is already present, move the doccomments
         # forward.
         if parent.hasName(self.name):
-            for i in xrange(0, len(parent.productions)):
+            for i in range(0, len(parent.productions)):
                 if parent.productions[i] is self:
                     break
-            for i in xrange(i + 1, len(parent.productions)):
+            for i in range(i + 1, len(parent.productions)):
                 if hasattr(parent.productions[i], 'doccomments'):
                     parent.productions[i].doccomments[0:0] = self.doccomments
                     break
@@ -422,7 +423,7 @@ class Native(object):
                 if self.modifier is not None:
                     raise IDLError("More than one ptr/ref modifier", aloc)
                 self.modifier = name
-            elif name in self.specialtypes.keys():
+            elif name in list(self.specialtypes.keys()):
                 if self.specialtype is not None:
                     raise IDLError("More than one special type", aloc)
                 self.specialtype = name
@@ -516,7 +517,7 @@ class Interface(object):
         if self.attributes.function:
             has_method = False
             for member in self.members:
-                if member.kind is 'method':
+                if member.kind == 'method':
                     if has_method:
                         raise IDLError("interface '%s' has multiple methods, but marked 'function'" % self.name, self.location)
                     else:
@@ -1003,9 +1004,9 @@ class Param(object):
 
         try:
             return self.realtype.nativeType(self.paramtype, **kwargs)
-        except IDLError, e:
+        except IDLError as e:
             raise IDLError(e.message, self.location)
-        except TypeError, e:
+        except TypeError as e:
             raise IDLError("Unexpected parameter attribute", self.location)
 
     def toIDL(self):
@@ -1053,7 +1054,7 @@ class IDLParser(object):
         'NATIVEID',
         ]
 
-    tokens.extend(keywords.values())
+    tokens.extend(list(keywords.values()))
 
     states = (
         ('nativeid', 'exclusive'),
@@ -1071,13 +1072,13 @@ class IDLParser(object):
     t_ignore = ' \t'
 
     def t_multilinecomment(self, t):
-        r'/\*(?s).*?\*/'
+        r'/\*.*?\*/'
         t.lexer.lineno += t.value.count('\n')
         if t.value.startswith("/**"):
             self._doccomments.append(t.value)
 
     def t_singlelinecomment(self, t):
-        r'(?m)//.*?$'
+        r'//[^\n]*'
 
     def t_IID(self, t):
         return t
@@ -1089,7 +1090,7 @@ class IDLParser(object):
         return t
 
     def t_LCDATA(self, t):
-        r'(?s)%\{[ ]*C\+\+[ ]*\n(?P<cdata>.*?\n?)%\}[ ]*(C\+\+)?'
+        r'%\{[ ]*C\+\+[ ]*\n(?P<cdata>.*?\n?)%\}[ ]*(C\+\+)?'
         t.type = 'CDATA'
         t.value = t.lexer.lexmatch.group('cdata')
         t.lexer.lineno += t.value.count('\n')
@@ -1214,7 +1215,7 @@ class IDLParser(object):
 
     def p_interface(self, p):
         """interface : attributes INTERFACE IDENTIFIER ifacebase ifacebody ';'"""
-        atts, INTERFACE, name, base, body, SEMI = p[1:]
+        atts, INTERFACE, name, base, body, SEMI = p[1], p[2], p[3], p[4], p[5], p[6]
         attlist = atts['attlist']
         doccomments = []
         if 'doccomments' in atts:
@@ -1428,6 +1429,7 @@ class IDLParser(object):
         self.lexer = lex.lex(object=self,
                              outputdir=outputdir,
                              lextab='xpidllex',
+                             reflags=re.DOTALL,
                              optimize=1)
         self.parser = yacc.yacc(module=self,
                                 outputdir=outputdir,
@@ -1461,5 +1463,5 @@ class IDLParser(object):
 if __name__ == '__main__':
     p = IDLParser()
     for f in sys.argv[1:]:
-        print "Parsing %s" % f
+        print("Parsing %s" % f)
         p.parse(open(f).read(), filename=f)
diff --git a/xpcom/typelib/xpt/tools/runtests.py b/xpcom/typelib/xpt/tools/runtests.py
index a86e6625df..7dcb1f1a1f 100644
--- a/xpcom/typelib/xpt/tools/runtests.py
+++ b/xpcom/typelib/xpt/tools/runtests.py
@@ -30,6 +30,7 @@
 # official policies, either expressed or implied, of the Mozilla
 # Foundation.
 
+from __future__ import print_function
 import difflib
 import os
 from StringIO import StringIO
@@ -66,9 +67,9 @@ if "MOZILLA_OBJDIR" in os.environ:
                 # now run xpt_dump on it
                 out2 = get_output(xptdump, fullpath)
                 if out != out2:
-                    print "diff %s" % f
+                    print("diff %s" % f)
                     for line in difflib.unified_diff(out2.split("\n"), out.split("\n"), lineterm=""):
-                        print line
+                        print(line)
                 self.assert_(out == out2, "xpt_dump output should be identical for %s" % f)
 
 
diff --git a/xpcom/typelib/xpt/tools/xpt.py b/xpcom/typelib/xpt/tools/xpt.py
index 67d40f7b2d..99a5a566b3 100755
--- a/xpcom/typelib/xpt/tools/xpt.py
+++ b/xpcom/typelib/xpt/tools/xpt.py
@@ -66,13 +66,18 @@ InterfaceType()        - construct a new object representing a type that
 """
 
 from __future__ import with_statement
+from __future__ import print_function
 import os
 import sys
 import struct
 import operator
 
+# Python 3: cmp() builtin was removed
+def cmp(a, b):
+    return (a > b) - (a < b)
+
 # header magic
-XPT_MAGIC = "XPCOM\nTypeLib\r\n\x1a"
+XPT_MAGIC = b"XPCOM\nTypeLib\r\n\x1a"
 TYPELIB_VERSION = (1, 2)
 
 
@@ -94,9 +99,7 @@ def M_add_class_attribs(attribs):
 
 
 def enum(*names):
-    class Foo(object):
-        __metaclass__ = M_add_class_attribs(enumerate(names))
-
+    class Foo(object, metaclass=M_add_class_attribs(enumerate(names))):
         def __setattr__(self, name, value):  # this makes it read-only
             raise NotImplementedError
     return Foo()
@@ -158,11 +161,20 @@ class Type(object):
     def __cmp__(self, other):
         return (
             # First make sure we have two Types of the same type (no pun intended!)
-            cmp(type(self), type(other)) or
+            cmp(type(self).__name__, type(other).__name__) or
             cmp(self.pointer, other.pointer) or
             cmp(self.reference, other.reference)
         )
 
+    def __lt__(self, other):
+        return self.__cmp__(other) < 0
+
+    def __eq__(self, other):
+        return self.__cmp__(other) == 0
+
+    def __hash__(self):
+        return hash((type(self).__name__, self.pointer, self.reference))
+
     @staticmethod
     def decodeflags(byte):
         """
@@ -249,6 +261,10 @@ class SimpleType(Type):
             cmp(self.tag, other.tag)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    __hash__ = Type.__hash__
+
     @staticmethod
     def get(data, tag, flags):
         """
@@ -303,6 +319,10 @@ class InterfaceType(Type):
             cmp(self.tag, other.tag)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    __hash__ = Type.__hash__
+
     @staticmethod
     def read(typelib, map, data_pool, offset, flags):
         """
@@ -364,6 +384,10 @@ class InterfaceIsType(Type):
             cmp(self.tag, other.tag)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    __hash__ = Type.__hash__
+
     @staticmethod
     def read(typelib, map, data_pool, offset, flags):
         """
@@ -425,6 +449,10 @@ class ArrayType(Type):
             cmp(self.tag, other.tag)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    __hash__ = Type.__hash__
+
     @staticmethod
     def read(typelib, map, data_pool, offset, flags):
         """
@@ -483,6 +511,10 @@ class StringWithSizeType(Type):
             cmp(self.tag, other.tag)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    __hash__ = Type.__hash__
+
     @staticmethod
     def read(typelib, map, data_pool, offset, flags):
         """
@@ -539,6 +571,10 @@ class WideStringWithSizeType(Type):
             cmp(self.tag, other.tag)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    __hash__ = Type.__hash__
+
     @staticmethod
     def read(typelib, map, data_pool, offset, flags):
         """
@@ -604,6 +640,10 @@ class Param(object):
             cmp(self.optional, other.optional)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    def __hash__(self): return id(self)
+
     @staticmethod
     def decodeflags(byte):
         """
@@ -740,6 +780,10 @@ class Method(object):
             cmp(self.result, other.result)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    def __hash__(self): return id(self)
+
     def read_params(self, typelib, map, data_pool, offset, num_args):
         """
         Read |num_args| ParamDescriptors representing this Method's arguments
@@ -851,7 +895,7 @@ class Method(object):
         """
         if self.name:
             self._name_offset = file.tell() - data_pool_offset + 1
-            file.write(self.name + "\x00")
+            file.write(self.name.encode('utf-8') + b"\x00")
         else:
             self._name_offset = 0
 
@@ -884,6 +928,10 @@ class Constant(object):
             cmp(self.value, other.value)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    def __hash__(self): return id(self)
+
     @staticmethod
     def read(typelib, map, data_pool, offset):
         """
@@ -928,7 +976,7 @@ class Constant(object):
         """
         if self.name:
             self._name_offset = file.tell() - data_pool_offset + 1
-            file.write(self.name + "\x00")
+            file.write(self.name.encode('utf-8') + b"\x00")
         else:
             self._name_offset = 0
 
@@ -1026,6 +1074,10 @@ class Interface(object):
             cmp(self.main_process_scriptable_only, other.main_process_scriptable_only)
         )
 
+    def __lt__(self, other): return self.__cmp__(other) < 0
+    def __eq__(self, other): return self.__cmp__(other) == 0
+    # __hash__ already defined above
+
     def read_descriptor(self, typelib, map, data_pool):
         offset = self._descriptor_offset
         if offset == 0:
@@ -1114,12 +1166,12 @@ class Interface(object):
         """
         if self.name:
             self._name_offset = file.tell() - data_pool_offset + 1
-            file.write(self.name + "\x00")
+            file.write(self.name.encode('utf-8') + b"\x00")
         else:
             self._name_offset = 0
         if self.namespace:
             self._namespace_offset = file.tell() - data_pool_offset + 1
-            file.write(self.namespace + "\x00")
+            file.write(self.namespace.encode('utf-8') + b"\x00")
         else:
             self._namespace_offset = 0
         for m in self.methods:
@@ -1157,7 +1209,7 @@ class Typelib(object):
 
         """
         def hexify(s):
-            return ''.join(["%02x" % ord(x) for x in s])
+            return ''.join(["%02x" % (x if isinstance(x, int) else ord(x)) for x in s])
 
         return "%s-%s-%s-%s-%s" % (hexify(iid[:4]), hexify(iid[4:6]),
                                    hexify(iid[6:8]), hexify(iid[8:10]),
@@ -1170,16 +1222,19 @@ class Typelib(object):
 
         """
         s = iid_str.replace('-', '')
-        return ''.join([chr(int(s[i:i+2], 16)) for i in range(0, len(s), 2)])
+        return bytes([int(s[i:i+2], 16) for i in range(0, len(s), 2)])
 
     @staticmethod
     def read_string(map, data_pool, offset):
         if offset == 0:
             return ""
-        sz = map.find('\x00', data_pool + offset - 1)
+        sz = map.find(b'\x00', data_pool + offset - 1)
         if sz == -1:
             return ""
-        return map[data_pool + offset - 1:sz]
+        result = map[data_pool + offset - 1:sz]
+        if isinstance(result, bytes):
+            result = result.decode('utf-8', 'replace')
+        return result
 
     @staticmethod
     def read(input_file):
@@ -1192,7 +1247,7 @@ class Typelib(object):
         filename = ""
         data = None
         expected_size = None
-        if isinstance(input_file, basestring):
+        if isinstance(input_file, str):
             filename = input_file
             with open(input_file, "rb") as f:
                 st = os.fstat(f.fileno())
@@ -1272,11 +1327,11 @@ class Typelib(object):
         headersize = (Typelib._header.size + 1)
         if headersize % 4:
             headersize += 4 - headersize % 4
-        fd.write("\x00" * headersize)
+        fd.write(b"\x00" * headersize)
         # save this offset, it's the interface directory offset.
         interface_directory_offset = fd.tell()
         # write out space for an interface directory
-        fd.write("\x00" * Interface._direntry.size * len(self.interfaces))
+        fd.write(b"\x00" * Interface._direntry.size * len(self.interfaces))
         # save this offset, it's the data pool offset.
         data_pool_offset = fd.tell()
         # write out all the interface descriptors to the data pool
@@ -1309,7 +1364,7 @@ class Typelib(object):
 
         """
         self._sanityCheck()
-        if isinstance(output_file, basestring):
+        if isinstance(output_file, str):
             with open(output_file, "wb") as f:
                 self.writefd(f)
         else:
@@ -1392,7 +1447,7 @@ def xpt_link(inputs):
         return Typelib.read(i)
 
     if not inputs:
-        print >>sys.stderr, "Usage: xpt_link <destination file> <input files>"
+        print("Usage: xpt_link <destination file> <input files>", file=sys.stderr)
         return None
     # This is the aggregate list of interfaces.
     interfaces = []
@@ -1532,7 +1587,7 @@ def xpt_link(inputs):
 
 if __name__ == '__main__':
     if len(sys.argv) < 3:
-        print >>sys.stderr, "xpt <dump|link> <files>"
+        print("xpt <dump|link> <files>", file=sys.stderr)
         sys.exit(1)
     if sys.argv[1] == 'dump':
         xpt_dump(sys.argv[2])
diff --git a/xulrunner/app/install_app.py b/xulrunner/app/install_app.py
index 6be8c5ecb5..d7707f2426 100644
--- a/xulrunner/app/install_app.py
+++ b/xulrunner/app/install_app.py
@@ -5,12 +5,13 @@
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
 # Min version of python is 2.7
+from __future__ import print_function
 import sys
 if ((sys.version_info.major != 2) or (sys.version_info.minor < 7)):
     raise Exception("You need to use Python version 2.7 or higher")
 
 import os, shutil, re, zipfile
-from ConfigParser import SafeConfigParser
+from configparser import SafeConfigParser
 
 # Platform-specific support
 # see https://developer.mozilla.org/en/XULRunner/Deploying_XULRunner_1.8
@@ -215,7 +216,7 @@ def handleCommandLine():
     except exn:
         shutil.rmtree(cmds.installDir)
         raise exn
-    print cmds.appName + " application installed to " + cmds.installDir
+    print(cmds.appName + " application installed to " + cmds.installDir)
 
 if __name__ == '__main__':
     handleCommandLine()
